"""
Django settings for adhesion project.

Generated by 'django-admin startproject' using Django 2.0.

For more information on this file, see
https://docs.djangoproject.com/en/2.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.0/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
import dj_database_url

BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get('SECRET_KEY', 'qxhj9!r#f7w7=ra%-5lm)rnv!fb)1n!qrz@-8=+^_btwryhhi+')
SECURE_PROXY_SSL_HEADER = ('HTTP_X_FORWARDED_PROTO', 'https')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = os.environ.get('DEBUG', False) == 'True'

if DEBUG:
    ALLOWED_HOSTS = os.environ.get('HOST', '*').split(',')
else:
    ALLOWED_HOSTS = ["127.0.0.1"]+os.environ.get('HOST', 'localhost').split(',')

CORS_ORIGIN_WHITELIST = [
                            'http://adhesion-api.asso-insa-lyon.fr',
                            'http://sstandva.bde-insa-lyon.fr',
                            'http://localhost:4200',
                            'http://localhost:3000',
                            'http://localhost:8000'
                        ] + os.environ.get('DOMAINS', 'http://localhost').split(',')

CORS_ALLOW_CREDENTIALS = True

CSRF_TRUSTED_ORIGINS = [
                           'adhesion.bde-insa-lyon.fr',
                           '127.0.0.1',
                           'localhost:4200',
                           'localhost:4201',
                           'localhost:3000',
                       ] + os.environ.get('DOMAINS', '').split(',')

INSTALLED_APPS = [
    'permissions',
    'django.contrib.admin',
    'django.contrib.admindocs',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'rest_framework',
    'django_filters',
    'phonenumber_field',
    'anymail',
    'corsheaders',
    'adhesion.api',
    'mercanet',
    'up2pay',
    'laverie',
    'wei',
    'rest_framework_swagger',
    'import_export',
    'minio_storage',
    'keycloak_oidc',  # datapunt-keycloak-oidc
]
MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'corsheaders.middleware.CorsPostCsrfMiddleware',
    'django.contrib.admindocs.middleware.XViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    # 'mozilla_django_oidc.middleware.SessionRefresh', #il est buggé, voir https://github.com/mozilla/mozilla-django-oidc/issues/248 (merge mais PyPi n'est pas mis à jour)
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

AUTHENTICATION_BACKENDS = [
    'keycloak_oidc.auth.OIDCAuthenticationBackend',
    'django.contrib.auth.backends.ModelBackend',
]
ROOT_URLCONF = 'adhesion.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')]
        ,
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'adhesion.wsgi.application'


REST_FRAMEWORK = {
    'DEFAULT_PERMISSION_CLASSES': (
        # 'mozilla_django_oidc.contrib.drf.OIDCAuthentication',
        'rest_framework.permissions.DjangoModelPermissions',
    ),
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'adhesion.api.permissions.KeycloakJWTAuthentication',
        'rest_framework.authentication.SessionAuthentication',
        'rest_framework.authentication.BasicAuthentication',
        'rest_framework.authentication.SessionAuthentication'
    ),
    'DEFAULT_PAGINATION_CLASS': 'rest_framework.pagination.LimitOffsetPagination'
}

# Database
# https://docs.djangoproject.com/en/2.0/ref/settings/#databases

DATABASES = {
    'default': dj_database_url.config(default='sqlite:///' + os.path.join(BASE_DIR, 'db.sqlite3'), conn_max_age=600)
}

ANYMAIL = {
    # (exact settings here depend on your ESP...)
    "MAILGUN_API_KEY": os.environ.get('MAILGUN_API_KEY', ''),
    "MAILGUN_SENDER_DOMAIN": os.environ.get('MAILGUN_DOMAIN', 'demo'),  # your Mailgun domain, if needed
}

EMAIL_BACKEND = "anymail.backends.mailgun.EmailBackend"
# EMAIL_BACKEND = 'django.core.mail.backends.console.EmailBackend'

DEFAULT_FROM_EMAIL = os.environ.get('DEFAULT_FROM_EMAIL', 'adhesion@bde-insa-lyon.fr')

# Password validation
# https://docs.djangoproject.com/en/2.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

AUTH_USER_MODEL = 'permissions.User'

# Internationalization
# https://docs.djangoproject.com/en/2.0/topics/i18n/

LANGUAGE_CODE = 'fr-fr'

TIME_ZONE = 'Europe/Paris'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.0/howto/static-files/

STATIC_URL = '/static/'
MEDIA_URL = '/uploads/'
STATIC_ROOT = os.path.join(BASE_DIR, "staticfiles")
MEDIA_ROOT = os.path.join(BASE_DIR, "uploads")

STATICFILES_DIRS = [os.path.join(BASE_DIR, "static")]
if os.environ.get('USE_MINIO_STATICFILES', 'False') == 'True':
    STATICFILES_STORAGE = "minio_storage.storage.MinioStaticStorage"
MINIO_STORAGE_ENDPOINT = os.environ.get('MINIO_ENDPOINT', 's3.home.ribes.ovh')
MINIO_STORAGE_ACCESS_KEY = os.environ.get('MINIO_ACCESS_KEY', 'adhesionstatic')
MINIO_STORAGE_SECRET_KEY = os.environ.get('MINIO_SECRET_KEY', 'password123')
MINIO_STORAGE_STATIC_BUCKET_NAME = os.environ.get('STATIC_BUCKET', 'adhesion-staticfiles')
MINIO_STORAGE_STATIC_URL = None  # pour l'autogénération minio url+bucket
MINIO_STORAGE_USE_HTTPS = os.environ.get('MINIO_STORAGE_USE_HTTPS', 'True') == 'True'


LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'formatters': {
        'log0': {
            'format': '[{name}] ({asctime}) : {message}',
            'style': '{'
        },
    },
    'handlers': {
        'console': {
            'class': 'logging.StreamHandler',
            'formatter': 'log0'
        },
        'mail_admins_debug': {
            'level': 'ERROR',
            'class': 'django.utils.log.AdminEmailHandler',
            'include_html': True,
        },
        'file': {
            'level': 'INFO',
            'class': 'logging.FileHandler',
            'filename': 'server_info.log',
        },
    },
    'loggers': {
        'django': {
            'handlers': ['console'],
            'level': 'INFO',
            'propagate': True,
        },
        'permissions': {
            'handlers': ['console'],
            'level': 'DEBUG'
        },
        'mercanet': {
            'handlers': ['file', 'console'],
            'level': 'DEBUG',
            'propagate': True,
        },
        'up2pay': {
            'handlers': ['file', 'console'],
            'level': 'DEBUG',
            'propagate': True,
        },
        'customer': {
            'handlers': ['file', 'console'],
            'level': 'DEBUG',
            'propagate': True,
        },
    },
}

### OIDC

OIDC_RP_CLIENT_ID = os.environ.get('OIDC_RP_CLIENT_ID', 'adhesion-api')
OIDC_RP_CLIENT_SECRET = os.environ.get('OIDC_RP_CLIENT_SECRET', '72049bdb-3be3-41cc-aaa6-89692d52dc6e')
KEYCLOAK_URL = os.getenv('KEYCLOAK_URL', 'http://sso.172.17.0.1.nip.io/auth/')  # avec un '/' à la fin
REALM_NAME = os.getenv('REALM_NAME', 'asso-insa-lyon')

OIDC_OP_AUTHORIZATION_ENDPOINT = os.getenv('OIDC_OP_AUTHORIZATION_ENDPOINT',
                                           KEYCLOAK_URL + 'realms/asso-insa-lyon/protocol/openid-connect/auth')
OIDC_OP_TOKEN_ENDPOINT = os.getenv('OIDC_OP_TOKEN_ENDPOINT',
                                   KEYCLOAK_URL + 'realms/asso-insa-lyon/protocol/openid-connect/token')
OIDC_OP_USER_ENDPOINT = os.getenv('OIDC_OP_USER_ENDPOINT',
                                  KEYCLOAK_URL + 'realms/asso-insa-lyon/protocol/openid-connect/userinfo')
OIDC_OP_JWKS_ENDPOINT = os.getenv('OIDC_OP_JWKS_ENDPOINT',
                                  KEYCLOAK_URL + 'realms/asso-insa-lyon/protocol/openid-connect/certs')
OIDC_OP_LOGOUT_ENDPOINT = os.getenv('OIDC_OP_LOGOUT_ENDPOINT',
                                    KEYCLOAK_URL + 'realms/asso-insa-lyon/protocol/openid-connect/logout')
OIDC_DRF_AUTH_BACKEND = 'mozilla_django_oidc.auth.OIDCAuthenticationBackend'

WEI_PRICE_TTC = int(os.getenv('WEI_PRICE_TTC', '40'))
PLACES_WEI = int(os.getenv('PLACES_WEI', '460'))
DATE_WEI = os.getenv('DATE_WEI', '2020-09-01')
WEI_PAYMENT_DISABLED = os.getenv("WEI_PAYMENT_DISABLED",
                                 "True") == "True"  # on désactive le paiement du Wei car il sera peut-être annulé
PUBLIC_FRONTEND_URL = os.getenv('FRONTEND_URL', 'http://localhost:3000')

MERCANET = {
    "INTERFACE_VERSION": os.environ.get(
        "MERCANET_INTERFACE_VERSION", "IR_WS_2.20"
    ),
    "KEY_VERSION": os.environ.get("MERCANET_KEY_VERSION", "1"),
    "MERCHANT_ID": os.environ.get("MERCANET_MERCHANT_ID", "211000021310001"),
    "URL": os.environ.get(
        "MERCANET_URL",
        "https://payment-webinit-mercanet.test.sips-atos.com/rs-services/v2/paymentInit",
    ),
    "SECRET_KEY": os.environ.get(
        "MERCANET_SECRET_KEY", "S9i8qClCnb2CZU3y3Vn0toIOgz3z_aBi79akR30vM9o"
    ),
    "REPONSE_AUTO_URL": os.environ.get(
        "MERCANET_REPONSE_AUTO_URL", "https://laptop-dev.ribes.ovh/mercanet/auto/"
    ),
    "RETURN_URL": os.getenv("RETURN_URL", "https://laptop-dev.ribes.ovh/mercanet/response_client/")
}

UP2PAY = {
    "PBX_SITE": "6069502",
    "PBX_RANG": "001",
    "PBX_IDENTIFIANT": "28387471",
    "PBX_REPONDRE_A": os.environ.get(
        "UP2PAY_IPN_URL",
        "http://93.9.9.232:8080/up2pay/auto/",
    ),

    "IPN_IPS": os.environ.get(
        "UP2PAY_IPN_IPS",
        "195.25.67.22,194.2.122.190",
    ).split(","),

    "UP2PAY_URL": os.environ.get(
        "UP2PAY_URL",
        "https://recette-tpeweb.e-transactions.fr/php/",
        #"https://tpeweb.e-transactions.fr/php/",
    ),
    "SECRET_KEY": os.environ.get(
        "UP2PAY_SECRET_KEY",
        ""
    ),
    "UP2PAY_PUBLIC_KEYS": os.environ.get(
        "UP2PAY_PUBLIC_KEYS",
        "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDe+hkicNP7ROHUssGNtHwiT2EwHFrSk/qwrcq8v5metRtTTFPE"
        "/nmzSkRnTs3GMpi57rBdxBBJW5W9cpNyGUh0jNXcVrOSClpD5Ri2hER/GcNrxVRP7RlWOqB1C03q4QYmwjHZ"
        "+zlM4OUhCCAtSWflB4wCKa1g88CjFwRw/PB9kwIDAQAB"
    ).split(","),
    "RETURN_URL": os.getenv("UP2PAY_RETURN_URL", "http://93.9.9.232:8080/up2pay/response_client/")
}

DISABLE_KEYCLOAK_CONN = os.environ.get('DISABLE_KEYCLOAK_CONN', 'False') != 'False'
